# Capitalisation Fixes

<center>

[![Modrinth Downloads](https://img.shields.io/modrinth/dt/JdXoJZy7?color=%23ff&label=Modrinth%20downloads&logo=download)](https://modrinth.com/resourcepack/capitalisation-fixes)
[![GitHub last commit](https://img.shields.io/github/last-commit/MMK21Hub/capitalisation-fixes)](https://github.com/MMK21Hub/Capitalisation-Fixes/commits)
[![GitHub Workflow Status](https://img.shields.io/github/actions/workflow/status/MMK21Hub/Capitalisation-Fixes/build-each-commit.yml)](https://github.com/MMK21Hub/Capitalisation-Fixes/actions/workflows/build-each-commit.yml)
</center>
<p>Capitalisation Fixes is a resource pack that fixes various bugs related to in-game and UI text, such as labels being improperly capitalised.</p>
<p>In Minecraft, all in-game names should be capitalised as proper nouns (e.g. "Oak Boat", "Bottle of Enchanting", "Golden Apple") and all 'action' button labels should also be in title case (e.g. "Import Settings", "Create Backup & Load", "Erase Cached Data"). In addition all titles should be in title case, including the titles of UI screens ("Video Settings") and the titles of advancements ("Monster Hunter").</p>

## Quick download links

- **[Capitalisation Fixes v2.17 for Minecraft 1.19.3](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/download/v2.17/Capitalisation-Fixes-v2.17-1.19.3.zip)** (Recommended)
- **[Capitalisation Fixes v2.17 for Minecraft 1.19.2](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/download/v2.17/Capitalisation-Fixes-v2.17-1.19.2.zip)**
- **[Capitalisation Fixes v2.0 for Minecraft 1.18.2](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/download/v2.0-compat/Capitalisation-Fixes-v2.0-compat.zip)**
- **[Capitalisation Fixes v1.2 for Minecraft 1.16.1](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/download/v1.2/Capitalisation-Fixes-v1.2.zip)**

## Information

- It currently targets the 1.19.3 release branch, but there is a "[compatibility release](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.0-compat)" that you can use in 1.18.x versions
- It supports two languages: `en_us` and `en_gb`. Other languages will not have the fixes applied to them.
- You can submit feedback and bug reports under the [Issues tab](https://github.com/MMK21Hub/Capitalisation-Fixes/issues), or you can DM `MMK21#2121` on Discord

To download, go to the [Releases tab](https://github.com/MMK21Hub/Capitalisation-Fixes/releases), choose the latest stable release and download the zip file. Install it just like any other resource pack. You can find the changelog [in a separate file](Changelog.md).

## Compatibility tables

The tables below show you the versions of Minecraft that different releases of Capitalisation Fixes will work with. The &#127775; symbol denotes the best version of the pack to use for each Minecraft version.

Newer releases of the pack (v2.9+) often have multiple variants for different Minecraft versions. These variants are available through the different files attached to each [GitHub Release](https://github.com/MMK21Hub/Capitalisation-Fixes/releases)
and the different versions published on [Modrinth](https://modrinth.com/resourcepack/capitalisation-fixes/versions). Each variant is optimised for its corresponding Minecraft version,
meaning that they contain all of the fixes applicable to that version — nothing more and nothing less.

The variant system also means that if you are using a recent version of the pack, you don't have to pay attention to these tables.

To benefit from the newest bugfixes, you should keep up-to-date with the latest release of the resource pack. If you're running an older version of Minecraft but still want to use the latest version of the pack,
you can [build a custom version of the pack](#build-tool).

### 1.19.3

|                                                                                  | 22w42a–22w46a | 1.19.3    |
| -------------------------------------------------------------------------------- | ------------- | --------- |
| **[v2.13](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.13)** | &#9989;       | &#9989;   |
| **[v2.14](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.14)** | &#9989;       | &#9989;   |
| **[v2.15](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.15)** | &#9989;       | &#9989;   |
| **[v2.16](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.16)** | &#9989;       | &#9989;   |
| **[v2.17](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.17)** | &#127775;     | &#127775; |

### 1.19

|                                                                                  | 22w11a    | 22w12a–13a | 22w14a    | 22w15a–16a | 22w17a–19a | 1.19-pre1+ | 1.19-pre5 | 1.19-rc1+ | 1.19      | 22w24a    | 1.19.1-pre1 | 1.19.1-rc1 | 1.19.1-pre2 | 1.19.1    | 1.19.2    |
| -------------------------------------------------------------------------------- | --------- | ---------- | --------- | ---------- | ---------- | ---------- | --------- | --------- | --------- | --------- | ----------- | ---------- | ----------- | --------- | --------- |
| **[v2.0](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.0)**   | &#127775; | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.1](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.1)**   | &#9989;   | &#127775;  | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.2](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.2)**   | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.3](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.3)**   | &#9989;   | &#9989;    | &#127775; | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.4](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.4)**   | &#9989;   | &#9989;    | &#9989;   | &#127775;  | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.5](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.5)**   | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#127775;  | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.6](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.6)**   | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#127775;  | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.7](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.7)**   | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#127775; | &#127775; | &#127775; | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.8](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.8)**   | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#127775; | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.9](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.9)**   | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#127775;   | &#127775;  | &#9989;     | &#9989;   | &#9989;   |
| **[v2.10](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.10)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.11](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.11)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#127775;   | &#9989;   | &#9989;   |
| **[v2.12](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.12)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.13](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.13)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.14](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.14)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#127775; | &#9989;   |
| **[v2.15](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.15)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.16](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.16)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#9989;   |
| **[v2.17](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.17)** | &#9989;   | &#9989;    | &#9989;   | &#9989;    | &#9989;    | &#9989;    | &#9989;   | &#9989;   | &#9989;   | &#9989;   | &#9989;     | &#9989;    | &#9989;     | &#9989;   | &#127775; |

### 1.18

|                                                                                                                           | 1.18.x  |
| ------------------------------------------------------------------------------------------------------------------------- | ------- |
| **[v2.0-compat](https://github.com/MMK21Hub/Capitalisation-Fixes/releases/tag/v2.0-compat)** (1.18 Compatibility Release) | &#9989; |

### Capitalisation Fixes v1

Capitalisation Fixes v1 (previously just "Capitalisation Fixes") was a resource pack that fixed some bugs in 20w21a+ where UI labels were incorrectly capitalised, and some minor grammar issues.

Unfortunately, Capitalisation Fixes v1 is not supported in versions newer than 1.16.2. It was discontinued because of a variety of reasons, e.g. the merger of many capitalisation bugs fixed by this pack into a single bug report on the bugtracker (making it harder to track which specific strings are fixed by this pack). Also, a large part of the pack was made obsolete by the release of 1.16 Pre-release 3, which added many of these fixes into the vanilla game.
|                                                                                                          | 20w21a to 20w22a | 1.16 Pre-releases | 1.16 to 1.16.1 | 20w27a to 20w29a |
| -------------------------------------------------------------------------------------------------------- | ---------------- | ----------------- | -------------- | ---------------- |
| **[v1.0](https://github.com/MMK21Hub/Capitalisation-Fixes/blob/master/old_changelog.md#v10-2020-05-21)** | &#9989;          | &#9989;           | &#9989;        | &#9989;          |
| **[v1.1](https://github.com/MMK21Hub/Capitalisation-Fixes/blob/master/old_changelog.md#v11-2020-05-31)** | &#9989;          | &#9989;           | &#9989;        | &#9989;          |
| **[v1.2](https://github.com/MMK21Hub/Capitalisation-Fixes/blob/master/old_changelog.md#v12-2020-06-10)** | &#9989;          | &#9989;           | &#9989;        | &#9989;          |

## Fixed strings

54 modified translation strings are included in the resource pack, fixing a total of 23 bugs. A lot of the issues are uncapitalised in-game names (which I've just referred to as "capitalisation"), but there are also other capitalisation and grammar issues in there.

Here's a summary of the statistics for different Minecraft versions. Some bugs aren't present in all versions, so each version may have different numbers of included fixes.

| Minecraft version        | Fixed bugs | Translation strings |
| ------------------------ | ---------- | ------------------- |
| Latest release (1.19.3)  | 20         | 50                  |
| Latest snapshot (1.19.3) | 20         | 50                  |
| Total                    | 23         | 54                  |

And here's the list of translation strings that have fixes:

- [Sneak 100 advancement description](https://bugs.mojang.com/browse/MC-250158) (missing serial comma)
- [Light as a Rabbit advancement description](https://bugs.mojang.com/browse/MC-226454) (missing space after ellipsis)
- [Wax On & Wax Off advancement descriptions](https://bugs.mojang.com/browse/MC-226484) (misleading terminology)
- [Bee Our Guest advancement description](https://bugs.mojang.com/browse/MC-250197) (inconsistent reference to Glass Bottles)
- [Render/Simulation distance sliders](https://bugs.mojang.com/browse/MC-237590) (capitalisation of UI widget labels)
- [Hide Lightning Flashes option description](https://bugs.mojang.com/browse/MC-236606) (capitalisation)
- ["Buffet world customization" title](https://bugs.mojang.com/browse/MC-222876) (capitalisation of screen titles)
- [Graphics warning buttons](https://bugs.mojang.com/browse/MC-220096) (capitalisation of action button labels)
- ["Include entities" button in the Structure Block interface](https://bugs.mojang.com/browse/MC-195781) (capitalisation of action button labels)
- [Target selector argument descriptions](https://bugs.mojang.com/browse/MC-128972) (Multiple grammar issues and inconsistencies. Their fixes are slightly opinionated, as there are multiple ways to fix the issues.)
- [Armour equipping subtitles](https://bugs.mojang.com/browse/MC-219541) (capitalisation)
- ["Sliding down a honey block" subtitle](https://bugs.mojang.com/browse/MC-206779) (capitalisation)
- ["Wandering Trader drinks milk/potion" subtitle](https://bugs.mojang.com/browse/MC-219533) (capitalisation)
- [Leash Knot subtitles](https://bugs.mojang.com/browse/MC-206548) (capitalisation)
- [Subtitles for Goat body parts](https://bugs.mojang.com/browse/MC-250968) (possessive apostrophes)
- ["Chat not allowed" message](https://bugs.mojang.com/browse/MC-252408) (missing full stop)
- [Strings that contain the word "gamemode"](https://bugs.mojang.com/browse/MC-256424) (should be spelt as "game mode")
- [World Loaded telemetry event description](https://bugs.mojang.com/browse/MC-257618) (incorrect tense of "pair")
- [Telemetry Data option menu button](https://bugs.mojang.com/browse/MC-258246) (missing ellipsis)
- [`/xp` output messages](https://bugs.mojang.com/browse/MC-203095) (always uses plural nouns)
- [Strings that use the right-quote-mark character](https://bugs.mojang.com/browse/MC-256422) (apostrophes should be used)

### Previously-fixed strings

These fixes used to be included in the pack but have since been fixed in the vanilla game, so they're longer necessary.
They can be found in old releases of the pack. <!-- FIXME: Update to take the new "variants" system into account. -->

- [Subtitles for Warden body parts](https://bugs.mojang.com/browse/MC-249422) Fixed in 22w14a
- ["You Got a Friend in Me" advancement title](https://bugs.mojang.com/browse/MC-250025) Fixed in 22w15a
- ["Feels like home" advancement title](https://bugs.mojang.com/browse/MC-237920) Fixed in 22w15a
- [Sound of Music advancement description](https://bugs.mojang.com/browse/MC-237922) Fixed in 22w15a
- [Star Trader advancement description](https://bugs.mojang.com/browse/MC-237924) Fixed in 22w15a
- [Serious Dedication advancement description](https://bugs.mojang.com/browse/MC-231458) Fixed in 22w15a<!-- Not in source code -->
- [Birthday Song advancement description](https://bugs.mojang.com/browse/MC-249980) Fixed in 1.18-pre1<!-- Present in source code -->
- [Goat Horn subtitles](https://bugs.mojang.com/browse/MC-250932) Fixed in 1.18-pre1
- [Report Chat message selection button](https://bugs.mojang.com/browse/MC-253102) Fixed in 1.19.1-pre1
- [Placeholder for unrelated messages in the Chat Reporting interface](https://bugs.mojang.com/browse/MC-253183) Fixed in 1.19.1-pre1
- [Terrorism or violent extremism chat report reason description](https://bugs.mojang.com/browse/MC-253223) Fixed in 1.19.1-pre5
- ["Erase cached data" button](https://bugs.mojang.com/browse/MC-244721) Fixed in 22w44a
- ["Data mode" and "Load mode" buttons in the Structure Block interface](https://bugs.mojang.com/browse/MC-195780) Fixed in 22w44a

## Build tool

The language files that end up in the resource pack aren't created by hand. Instead, a Javascript tool applies a list of "fixes" to the vanilla translation strings, then packages all of its changes into a resource pack that can be distributed. The source code for all the fixes is in the [`src/fixes.ts`](src/fixes.ts) file, and [all the other `.ts` files](https://github.com/MMK21Hub/Capitalisation-Fixes/search?l=typescript) are the source code for the build tool.

If you want to build the pack yourself, the setup is similar to any other Node.js project:

```yaml
# Clone this repository
git clone https://github.com/MMK21Hub/Capitalisation-Fixes.git

# Move into the folder containing the cloned repository
cd Capitalisation-Fixes

# Resolve and install dependencies
yarn install

# Compile the code into executable JavaScript
yarn build
```

Then, you can actually run the build script. Here are some usage examples:

```yaml
# Build the resource pack. The output will be in the `out` folder, 
# and the zip file will be named after the targeted Minecraft version.
# If multiple versions are targeted, there will be one zip file for each.
node dist/main.js

# Specify a version number to use in the outputted zip filename
node dist/main.js v2.6

# Print some statistics instead of building the pack
# By default, it counts any fixes that are relevant to any of the target versions
node dist/main.js --stats

# Print the statistics, but only include fixes that are relevant to the latest snapshot
node dist/main.js --stats --latest-snapshot

# Print the statistics for the latest stable release of Minecraft
node dist/main.js --stats --latest-release
```

At the moment, you can't configure the output using command line arguments. The build configuration can be changed by editing the [`src/main.ts`](src/main.ts) file instead. (Make sure that you run `yarn build` after editing any source files, or alternatively use `yarn watch` to automatically compile the code whenever you make changes.)

## `new-version.sh`

This is a utility script for Linux systems that automates part of the process of releasing a new version of Capitalisation Fixes. You should provide a name for the new version as the first (and only) argument, e.g. `./new-version.sh v2.1`.

It performs three main jobs:

- Run the build tool to create the `.zip` files that can be distributed with the release.
- Bump the version in the project's [package.json file](package.json).
- Push any commits that only exist locally, to make sure that the tag on GitHub is based on the most recent commit.
- Create a new git tag to mark the version. It then pushes the tag to GitHub.

For detailed information, check [the file itself](new-version.sh).

## Related projects

### Resource Packs

| Name                     | Version(s)  | Fixed bug(s)         | Notes         |
| ------------------------ | ----------- | -------------------- | ------------- |
| **Capitalisation Fixes** | 1.19–1.19.3 | [20](#fixed-strings) | You are here! |

#### [Vanilla Tweaks](https://vanillatweaks.net/picker/resource-packs/)

| Name               | Version(s)  | Fixed bug(s)                                          | Notes                                                               |
| ------------------ | ----------- | ----------------------------------------------------- | ------------------------------------------------------------------- |
| Item Stitching Fix | 1.14–1.19.3 | [MC-73186](https://bugs.mojang.com/browse/MC-73186)   | Only contains fixes for commonly-held items, such as food and tools |
| Blaze's Rods Fix   | 1.14–1.19.3 | [MC-144327](https://bugs.mojang.com/browse/MC-144327) |                                                                     |
| Cactus Bottom Fix  | 1.16–1.19.3 | [MC-150572](https://bugs.mojang.com/browse/MC-150572) |                                                                     |
| Iron Bars Fix      | 1.14–1.19.3 | [MC-192420](https://bugs.mojang.com/browse/MC-192420) |                                                                     |
| Hopper Bottom Fix  | 1.14–1.19.3 | [MC-203399](https://bugs.mojang.com/browse/MC-203399) |                                                                     |

### Fabric Mods

| Name                                                            | Version(s)  | Fixed bug(s)                                                            | Side   | Notes                                                                                |
| --------------------------------------------------------------- | ----------- | ----------------------------------------------------------------------- | ------ | ------------------------------------------------------------------------------------ |
| [Carpet-Fixes](https://modrinth.com/mod/carpet-fixes)           | 1.17–1.19.3 | [260+](https://github.com/fxmorin/carpet-fixes/wiki/Available-Settings) | Server | Requires [Carpet Mod](https://github.com/gnembon/fabric-carpet) to also be installed |
| [More Culling](https://modrinth.com/mod/moreculling)            | 1.18–1.19.3 | [5](https://github.com/fxmorin/MoreCulling#current-bugs-fixed)          | Client |                                                                                      |
| [Head Name Fix](https://modrinth.com/mod/headfix)               | 1.16—1.19.3 | [MC-174496](https://bugs.mojang.com/browse/MC-174496)                   | Server |                                                                                      |
| [Blanket client-tweaks](https://modrinth.com/mod/blanket)       | 1.18–1.19.3 | [8](https://github.com/BlanketMC/blanket-client-tweaks)                 | Client | Also includes "QoL improvements and tweaks" (disabled by default)                    |
| [Raised](https://modrinth.com/mod/raised)                       | 1.16–1.19.3 | [MC-67532](https://bugs.mojang.com/browse/MC-67532)                     | Client |                                                                                      |
| [Title Fix Mod](https://modrinth.com/mod/title-fix-mod)         | 1.15–1.19.3 | [MC-55347](https://bugs.mojang.com/browse/MC-55347)                     | Client |                                                                                      |
| [Item Model Fix](https://github.com/PepperCode1/Item-Model-Fix) | 1.16–1.19   | [MC-73186](https://bugs.mojang.com/browse/MC-73186)                     | Client | [Issue for 1.19.3 support](https://github.com/PepperCode1/Item-Model-Fix/issues/20)  |
| [Title Fixer](https://modrinth.com/mod/title-fixer)             | 1.16–1.19   | [MC-238712](https://bugs.mojang.com/browse/MC-238712)                   | Client |                                                                                      |
| [Mc122477Fix](https://modrinth.com/mod/mc122477fix)             | 1.16–1.17   | [MC-122477](https://bugs.mojang.com/browse/MC-122477)                   | Client |
| [Subspace Train](https://modrinth.com/mod/subspace-train)       | 1.17.1      | [MC-67](https://bugs.mojang.com/browse/MC-67)                           | Server |                                                                                      |
